<template>
  <q-dialog
    ref="dialog"
    @hide="$emit('hide')"
  >
    <q-card class="q-dialog-plugin">
      <q-card-section>
        <div
          class="text-h5 text-weight-bolder text-grey-9 q-pb-sm"
          v-text="'Categoria'"
        />
      </q-card-section>

      <q-card-section>
        <q-form class="row q-gutter-y-sm">
          <q-input
            v-model="form.label"
            class="col-12"
            label="Nome"
            color="primary"
            bottom-slots
            outlined
            dense
            :error="$v.form.label.$error"
          >
            <template v-slot:error>
              <div
                v-for="(message, index) in errorMessages($v.form.label)"
                :key="index"
                v-text="message"
              />
            </template>
          </q-input>

          <q-input
            v-model="form.sublabel"
            class="col-12"
            label="Descrição"
            color="primary"
            bottom-slots
            outlined
            dense
          />

          <q-select
            v-model="form.type"
            :options="options"
            class="col-12"
            label="Tipo"
            color="primary"
            options-cover
            options-dense
            bottom-slots
            map-options
            emit-value
            outlined
            dense
            :error="$v.form.type.$error"
          >
            <template v-slot:error>
              <div
                v-for="(message, index) in errorMessages($v.form.type)"
                :key="index"
                v-text="message"
              />
            </template>
          </q-select>

          <q-input
            ref="color"
            v-model="form.color"
            class="col-12"
            label="Cor"
            color="primary"
            bottom-slots
            outlined
            dense
            :error="$v.form.color.$error"
          >
            <template v-slot:append>
              <q-icon
                class="cursor-pointer"
                name="las la-palette"
              >
                <q-popup-proxy
                  ref="popupColor"
                  transition-show="scale"
                  transition-hide="scale"
                  :target="$refs.color"
                  @hide="$refs.icon.focus()"
                >
                  <q-color
                    v-model="form.color"
                    default-view="palette"
                    format-model="hex"
                    flat
                    @change="$refs.popupColor.hide()"
                  />
                </q-popup-proxy>
              </q-icon>
            </template>

            <template v-slot:error>
              <div
                v-for="(message, index) in errorMessages($v.form.color)"
                :key="index"
                v-text="message"
              />
            </template>
          </q-input>

          <q-input
            ref="icon"
            v-model="form.icon"
            class="col-12"
            label="Ícone"
            color="primary"
            bottom-slots
            outlined
            dense
          >
            <template v-slot:append>
              <q-icon
                class="cursor-pointer"
                name="las la-puzzle-piece"
              >
                <q-popup-proxy
                  ref="popupIcon"
                  transition-show="scale"
                  transition-hide="scale"
                  :target="$refs.icon"
                  @hide="filter = ''"
                >
                  <q-input
                    v-model="filter"
                    class="q-pa-sm"
                    placeholder="Buscar"
                    color="primary"
                    debounce="300"
                    autofocus
                    outlined
                    dense
                  >
                    <template v-slot:append>
                      <q-icon name="search" />
                    </template>
                  </q-input>

                  <q-icon-picker
                    v-model="form.icon"
                    style="height: 184px; width: 336px;"
                    selected-background-color="primary"
                    :pagination.sync="pagination"
                    icon-set="fontawesome-v5"
                    selected-color="white"
                    :filter="filter"
                    color="grey"
                    animated
                    @input="$refs.popupIcon.hide()"
                  />
                </q-popup-proxy>
              </q-icon>
            </template>
          </q-input>
        </q-form>
      </q-card-section>

      <q-card-actions align="right">
        <q-btn
          class="q-mr-sm q-mb-sm"
          color="primary"
          label="OK"
          @click="save"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script>
import { Component as QIconPicker } from '@quasar/quasar-ui-qiconpicker'
import { ErrorMessagesMixin } from '../../mixin/error-messages'
import { required } from 'vuelidate/lib/validators'

const hex = /^#[0-9a-fA-F]{3}([0-9a-fA-F]{3})?$/
const isHex = (val) => hex.test(val)

export default {
  name: 'FormCategory',
  components: { QIconPicker },
  mixins: [ErrorMessagesMixin],
  props: {
    value: {
      type: Object,
      required: true
    },
    options: {
      type: Array,
      required: true
    }
  },
  data () {
    return {
      form: this.value,
      pagination: {
        itemsPerPage: 24,
        page: 1
      },
      filter: ''
    }
  },
  validations: {
    form: {
      label: {
        required
      },
      type: {
        required
      },
      color: {
        required,
        isHex
      }
    }
  },
  methods: {
    show () {
      this.$refs.dialog.show()
    },
    hide () {
      this.$refs.dialog.hide()
    },
    async save () {
      this.$v.form.$touch()

      if (this.$v.form.$error) {
        return undefined
      }

      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: this.form.id ? 'PATCH' : 'POST',
          url: `/Categories/${this.form.id || ''}`,
          data: JSON.parse(JSON.stringify(this.form))
        }

        await this.$axios(axiosConfig)

        this.axiosSuccess('Salvo com sucesso')
      } catch (err) {
        this.axiosCatch(err)
      } finally {
        this.$q.loading.hide()
        this.$emit('ok')
        this.hide()
      }
    }
  }
}
</script>
